 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Dos Support Code
  *
  * (c) 1997 Tim Gunn (06-28-97 01:40pm)
  *
  */

#include <stdio.h>
#include <dpmi.h>
#include <dos.h>
#include <go32.h>
#include <conio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <unistd.h>
#include <sys/farptr.h>

#include "dos-supp.h"

#define Rcarry (dosregs.x.flags&1)
#define SEL _go32_info_block.selector_for_linear_memory
#define TBaddr _go32_info_block.linear_address_of_transfer_buffer
#define segoff(x,y,z) ((x)=(z)>>4,(y)=(z)&15)

#define NO_WIN          0x00
#define WIN_386_X	0x01
#define WIN_REAL	0x81
#define WIN_STANDARD	0x82
#define WIN_ENHANCED	0x83

#define TB textbackground
#define TC textcolor
#define CURSON _setcursortype(_NORMALCURSOR);
#define CURSOFF _setcursortype(_NOCURSOR);
#define SCRON _wscroll = 1;
#define SCROFF _wscroll = 0;

__dpmi_regs dosregs;

int nfloppies;
int complev=9; //level of gzip compression to use
int exttst=1; //whether to use file extension testing.

int SETTC=15; //tui text colour.     (15=while)
int SETTB=1;  //tui back colour.     (1=blue)
int SETHL=14; //tui hi-light colour. (14=yellow)
int _CWINX = 1,_CWINY = 1,_CWINX2 = 80,_CWINY2 = 50;

void tui_curson(void){ _setcursortype(_NORMALCURSOR); }
void tui_cursoff(void){ _setcursortype(_NOCURSOR); }
void tui_textback(int c){ textbackground(c); }
void tui_textcolr(int c){ textcolor(c); }
void tui_reset(void)
{
    highvideo();
    _set_screen_lines(50); window(1,1,80,50);
    tui_textcolr(SETTC); tui_textback(SETTB); clrscr();
}
void tui_scrollon(void){ _wscroll = 1; }
void tui_scrolloff(void){ _wscroll = 0; }
void tui_shutdown(void)
{
    tui_textcolr(LIGHTGRAY); tui_textback(BLACK); clrscr();
}

void tui_cleararea(int x,int y,int x2,int y2)
{
    window(x,y,x2,y2);
    clrscr();
    window(1,1,80,50);
}

void tui_drawbox(int x, int y, int x2, int y2)
{
    int i;
    gotoxy(x,y); cprintf("");
    for(i=0;i<x2-x-1;i++){ gotoxy(x+i+1,y); cprintf(""); }
    cprintf("");
    gotoxy(x,y2); cprintf("");
    for(i=0;i<x2-x-1;i++){ gotoxy(x+i+1,y2); cprintf(""); }
    gotoxy(x2,y2);cprintf("");
    for(i=y+1;i<y2;i++) {
        gotoxy(x,i); cprintf("");
        gotoxy(x2,i); cprintf("");
    }
}

struct dialog dlog(struct dialog dl,int xcoord,int ycoord,int xcoord2,int ycoord2,char *title)
{
    dl.dx = xcoord; dl.dy = ycoord; dl.dx2 = xcoord2; dl.dy2 = ycoord2;
    gettext(dl.dx-1,dl.dy-1,dl.dx2+1,dl.dy2+1,dl.dbuff);
    window(1,1,80,25); tui_drawbox(dl.dx-1,dl.dy-1,dl.dx2+1,dl.dy2+1);
    gotoxy(dl.dx,dl.dy-1); cprintf("%s",title);
    window(dl.dx,dl.dy,dl.dx2,dl.dy2);
    dl.dlx = _CWINX; dl.dly = _CWINY; dl.dlx2 = _CWINX2; dl.dly2 = _CWINY2;
    _CWINX = dl.dx; _CWINY = dl.dy; _CWINX2 = dl.dx2 ;_CWINY2 = dl.dy2;
    clrscr();
    return dl;
}

void dlogdie(struct dialog dl)
{
    window(dl.dlx,dl.dly,dl.dlx2,dl.dly2);
    _CWINX = dl.dlx; _CWINY = dl.dly; _CWINX2 = dl.dlx2; _CWINY2 = dl.dly2;
    puttext(dl.dx-1,dl.dy-1,dl.dx2+1,dl.dy2+1,dl.dbuff);
}

void tui_errorbox(char *errortxt)
{
    int half;
    struct dialog dl;
    half = strlen(errortxt)/2;

    tui_textcolr(SETTC); tui_textback(SETTB);

    dl = dlog(dl,35-half,10,45+half,15,"UAE System notice");

    gotoxy(5,3); cprintf("%s",errortxt);
    gotoxy(half+1,5); cprintf("HIT A KEY");
    getch();

    dlogdie(dl);
}

int tuiscan(char *prompt, int maxlen, char *data)
{
    int half,i,len,out=0;
    char key;
    char *tmp=(char *)calloc(21,sizeof(char));
    struct dialog dl;
    if((int)strlen(prompt)>maxlen) half = strlen(prompt)/2;
    else half = maxlen/2;

    len = strlen(data);

    tui_textcolr(SETTB); tui_textback(SETTC); tui_curson();
    dl = dlog(dl,35-half,10,45+half,15,"Data Entry");
    gotoxy(5,2);cprintf("%s",prompt);

    tui_textcolr(SETTC); tui_textback(SETTB);
    for(i=0;i<maxlen;i++) { gotoxy(5+i,4); cprintf(" "); }
    gotoxy(5,4);

    if(len>0) {
        if(len>maxlen)len=maxlen;
        for(i=0;i<len;i++) { gotoxy(5+i,4); cprintf("%c",data[i]); }
        strcpy(tmp, data);
    }
    maxlen--;
    do{
        key = getch();
        switch(key)
        {
            case 0:                 /* case 0: begin*/
            switch(getch())
            {
            case 75:                /* left  */
                if(len>0) {
                    len--;
                    gotoxy(5+len,4);
                }
            break;
                                    /* right */
            case 77:
                if(len<maxlen+1) {
                    len++;
                    gotoxy(5+len,4);
                }
            break;
            }
            break;                  /* case 0: end */

            case 8:                 /* backspace */
                if(len>0) {
                    len--;
                    tmp[len]=' ';

                    if (len <= strlen(tmp))
                        memmove(tmp+len, tmp+len+1, strlen(tmp)-len);
                    gotoxy(5,4); cprintf("%s", tmp); cprintf(" ");
                    gotoxy(5+len,4);
                }
            break;

            case 13:                /* enter */
                len=strlen(tmp);
                out=1;              /* update data */
            break;

            case 27: out=0; break;  /* esc, discard changes */
            default:
            if(len-1<maxlen) {
                tmp[len]=key;
                len++;
                gotoxy(4+len,4); cprintf("%c",key);
            }
            break;
        }

    }while(key!=13 && key!=27);
    tui_cursoff();
    tmp[len]=0;
    if(out) strcpy(data, tmp);
    cfree(tmp);
    dlogdie(dl);
    return(out);
}

void MakeBlankFile(char *name,long size)
{
    FILE *disk;
    long disksize=0;
    disksize=((size*1024)+16383)/16384*16384;
    disk = fopen(name, "wb");
    fseek(disk, disksize-1, SEEK_SET);
    fputc(0, disk);
    fclose(disk);
}

long diskfree(void)
{
    {
        struct diskfree_t free;
        long avail;

        if (_dos_getdiskfree(0, &free) != 0) {
            printf("Error in _dos_getdiskfree() call\n");
            exit(1);
        }
    avail = (long) free.avail_clusters
          * (long) free.bytes_per_sector
          * (long) free.sectors_per_cluster;

    return avail;
    }
}

// usage:- win_mode = windows_version( &hver, &lver );
int windows_version(int *major,int *minor)
{
  *major = 0;
  *minor = 0;
  dosregs.x.ax = 0x1600;
  __dpmi_int( 0x2F, &dosregs );
  switch ( dosregs.h.al )
  {
    case 0x01:
    case 0xFF: *major =2; *minor =0; return WIN_386_X;
    case 0x00:
    case 0x80:
        dosregs.x.ax = 0x4680;
        __dpmi_int( 0x2F, &dosregs );
        if ( dosregs.h.al == 0x80 ) return NO_WIN;
        else
		{
            dosregs.x.ax = 0x1605;
            dosregs.x.bx = dosregs.x.si = dosregs.x.cx = dosregs.x.es = dosregs.x.ds == 0x0000;
            dosregs.x.dx = 0x0001;
            __dpmi_int( 0x2F, &dosregs );
            if ( dosregs.x.cx == 0x0000 )
            {
                dosregs.x.ax = 0x1606;
                __dpmi_int( 0x2F, &dosregs );
                return WIN_REAL;
            }
            else return WIN_STANDARD;
        }
            default: *major = dosregs.h.al;
            *minor = dosregs.h.ah;
            return WIN_ENHANCED;
	}
}

char *os_ver_str(void)
{
    int mode,ver,sver;
    static char buff[100];
    mode = windows_version(&ver,&sver);
    switch(mode)
    {
        case NO_WIN: sprintf(buff,"DOS"); break;
        case WIN_386_X: sprintf(buff,"Windows386 2.0"); break;
        case WIN_REAL: sprintf(buff,"Windows Real Mode V%d.%d",ver,sver); break;
        case WIN_STANDARD:sprintf(buff,"Windows Standard mode V%d.%d",ver,sver); break;
        case WIN_ENHANCED:sprintf(buff,"Windows V%d.%d",ver,sver); break;

    }
    return buff;
}

/* current drive */
int drive()
{
    dosregs.x.ax=0x1900;
    __dpmi_int(0x21, &dosregs);
    return (dosregs.x.ax&255)+'a';
}

void set_current_drive(int i)
{
    dosregs.x.ax=0xe00;
    dosregs.x.dx=(i-'A')&31;
    __dpmi_int(0x21, &dosregs);
}

int driveexists(char D)
{
    int i,j=drive();
    set_current_drive(D);
    i=(drive()&31)==(D&31);
    set_current_drive(j);
    return i;
}

int tui_supp_init(void)
{
    int i;
	for(i='A';i<='Z';i++)
	{
        dosregs.x.ax=0x4408; dosregs.x.bx=i&31;
        __dpmi_int(0x21, &dosregs);
        if(Rcarry?:dosregs.x.ax&15)break;
    }
    nfloppies=i-'A';
    return 1;
}

char *tuifilereq(char *spec, char *pathbuf)
{
    struct bstring *files;
    int i=0,y=0,z,key=0,cur=0,ysize=17,color,pos;
    char clearbuf[22],tempstr[256];
    DIR *d;
    struct dirent *de;
    char *spath,*ext;
    int ndrives = 0,done,sel=0,count=0;
    char drives[27] = "";
    char tpath[4] = " :\\";
    char *tmp = (char *)calloc(30,sizeof(char));

    for(tpath[0] = 'A'; tpath[0] <= 'Z'; tpath[0]++)
    {
	if (driveexists(tpath[0])) drives[ndrives++] = tpath[0];
    }
    drives[ndrives] = '\0';

    i=0;
    tui_textcolr(SETTC); tui_textback(SETTB); clrscr(); tui_cursoff();
    SCROFF tui_drawbox(1,1,80,50); //SCRON
    gotoxy(3,2); cprintf("FileReqester v0.1");
    gotoxy(3,3); cprintf("");
    for(i=0;i<17;i++) { gotoxy(28,i+4); cprintf(""); }
    gotoxy(3,19); cprintf("");
    gotoxy(28,19); cprintf("");
    gotoxy(3,21); cprintf("");
    gotoxy(28,21); cprintf("");
    gotoxy(28,3); cprintf("");
    gotoxy(34,6);cprintf("A=Show All files/UAE files"); //sel function -2
    gotoxy(34,7);cprintf("D=Delete File"); //sel function -3
    gotoxy(34,8);cprintf("R=Rename File"); //sel function -4
    gotoxy(34,9);cprintf("M=Make Blank ADF File"); //sel function -5
    gotoxy(34,10);cprintf("C=Compress File");//sel function -6

    for (done = 0; !done;)
    {
        gotoxy(18,2);
	cprintf("                                                  ");
	gotoxy(18,2);
	cprintf("%s",pathbuf);

        while(!(d = opendir(pathbuf)))getcwd(pathbuf,256);
        while((de = readdir(d)))count++;
        count=count+ndrives+1;
        files = (struct bstring *)calloc(count , sizeof(struct bstring));
        count=0;

	for(i = 0; (tpath[0] = drives[i]); i++) {
            strcpy(files[count].data,tpath);
            files[count].val=-1;
            count++;
        }

        rewinddir(d);
        while ( (de =readdir(d)) )
        {
	    if(!access(catpath(pathbuf,de->d_name),D_OK))
            {
	       strncpy(files[count].data,de->d_name,20);
	       files[count].data[20] = '\0';
               files[count].val=1;
               count++;
            }
            else
            {   if(exttst)
                {
                    ext = strrchr(de->d_name, '.');
                    if (ext != NULL)
                    {
                        ext++;
                        if(!stricmp(ext,"z")  ||
                            !stricmp(ext,"gz") ||
                            !stricmp(ext,"adz") ||
                            !stricmp(ext,"roz") ||
			    !stricmp(ext,"adf") ||
                            !stricmp(ext,"rom") ||
                            !stricmp(ext,"cfg") ||
                        0)
                        {
                            strncpy(files[count].data,de->d_name,20);
			    files[count].data[20] = '\0';
			    files[count].val=0;
                            count++;
                        }
                    }
                }
                else
                {
                    strncpy(files[count].data,de->d_name,20);
		    files[count].data[20] = '\0';
		    files[count].val=0;
		    count++;
		}
	    }
	}
	closedir(d);

	qsort(files, count,sizeof(struct bstring),fCmp);

	i=0; y=0; key=0; cur=0; sel=0;

	for(i=0;i<21;i++)clearbuf[i]=' ';clearbuf[21]=0;
	for(i=0;i<ysize;i++){ gotoxy(5,3+i+1); cprintf("%s",clearbuf); }

	gotoxy(5,ysize+2); for(i=0;i<21;i++) cprintf("");
	while(key!=13) {
	    switch(key)
	    {
                case 73: cur=cur-10; break;
                case 81: cur=cur+10; break;
                case 72: cur--; break;
                case 80: cur++; break;
                case 27:
                    tui_textback(SETTB); tui_textcolr(SETTC);
/*                  files[0].data[0]=0;
		    return files[0].data;*/
		    return("");
                break;
                case 'a':
		    sel=-2; break;
		case 'd':
		    sel=-3; break;
		case 'r':
		    sel=-4; break;
		case 'm':
                    sel=-5; break;
                case 'c':
                    sel=-6; break;
            }
            if(sel<0)break;
            if(count-y<ysize-2) z=count; else z=ysize-2;
            if(cur>z-1) { y=y+cur-z+1; cur=z-1; }
            if(cur<0) { y=y+cur-1; cur=0; }
            if(y<0) y=0;
            if(y>count-z) y=count-z;
            for(i=y;i<y+z;i++)
            {
                if(files[i].val!=0)tui_textcolr(SETHL);else tui_textcolr(SETTC);
                if(i==y+cur)tui_textback(SETTC);else tui_textback(SETTB);
                gotoxy(5,4+i-y);
                strcpy(tmp, files[i].data);
                for (pos=strlen(tmp);pos<21;pos++)tmp[pos]=' ';
		tmp[21]='\0';
		cprintf("%s",tmp);
            }
            tui_textback(SETTB); tui_textcolr(SETTC);
            strcpy(tmp, files[y+cur].data);
            for (pos=strlen(tmp);pos<21;pos++)tmp[pos]=' ';
	    tmp[21]='\0';
	    gotoxy(5,ysize+3);
	    cprintf("%s",tmp);

	    key = getch();
	}

	tui_textback(SETTB); tui_textcolr(SETTC);

	if(sel<0)
	{
	switch(sel)
	   {
	    case -2: exttst=!exttst;
	    break;
	    case -3:
		remove(catpath(pathbuf,files[y+cur].data));
	    break;
	    case -4:
		strcpy(tempstr,files[y+cur].data);
		if(tuiscan("Enter new name for file",20,tempstr)) {
		    if(strcmp(tempstr, files[y+cur].data))
		    rename(catpath(pathbuf,files[y+cur].data),catpath(pathbuf,tempstr));
		}
	    break;
	    case -5:
		tempstr[0]=0;
		if(tuiscan("Enter new ADF name:",20,tempstr))
		    MakeBlankFile(catpath(pathbuf,tempstr),880);
	    break;
	    case -6:
		gotoxy(5,30);cprintf("Compressing File at level %d, Please Wait...",complev);
		sprintf(tempstr,"gzip -q -%d %s",complev,catpath(pathbuf,files[y+cur].data));
		system(tempstr);
		gotoxy(5,30);cprintf("                                           ");
	    break;
	    }
	}
	else
	{
	    sel = y+cur;
	    if(files[sel].val==1)
	    {
		if( (strcmp(files[sel].data,"..")==0)&&(pathbuf[strlen(pathbuf)-1]!='/') )
		{
		    while(pathbuf[strlen(pathbuf)-1]!='/' && strlen(pathbuf)!=0)
			pathbuf[strlen(pathbuf)-1]='\0';
		    if(strlen(pathbuf)>3)pathbuf[strlen(pathbuf)-1]='\0'; //gets rid of last '/'
		}
		else
		{
		    if(strcmp(files[sel].data,".")!=0)
		    {
			strcpy(pathbuf,catpath(pathbuf,files[sel].data));
		    }
		}
		free(files);
	    }
	    else
	    {
		if(files[sel].val==-1)strcpy(pathbuf,files[sel].data);
		else done=1;
	    }
	}
    }

    if (sel==0 || sel==-1) {
	sel=0;
/*      files[sel].data[0]=0;
	return files[sel].data;*/
	return("");
    }
    cfree(tmp);
    return catpath(pathbuf,files[sel].data);
}

int fCmp (const void *vp, const void *vq)
{
    int diff;
    const struct bstring *a = (const struct bstring *)vp;
    const struct bstring *b = (const struct bstring *)vq;

    if(a->val == b->val)diff = stricmp(a->data,b->data);
    else diff = a->val < b->val;

    return(diff);
}

char *catpath(char *path,char *file)
{
    char *tempbuf = (char *)calloc(256,1);
    strcpy(tempbuf,path);
    if(path[strlen(path)-1]!='\\')
        if(path[strlen(path)-1]!='/')strcat(tempbuf,"/");
    strcat(tempbuf,file);
    cfree(tempbuf);
    return(tempbuf);
}

char *cutpath(char *path)
{
    while(path[strlen(path)-1]!='/' && strlen(path)!=0)
        path[strlen(path)-1]='\0';
    return(path);
}

int menu_cur = 0;

int tui_menubrowse(struct bstring *p,int count)
{
    int i=0,y=0,z,key=0,color,pos;
    int xp=5, yp=3, xsize=21,ysize=17;
    char clearbuf[xsize];
    char *tmp = (char *)calloc(30,1);

    tui_textcolr(SETTC); tui_textback(SETTB);

    for(i=0;i<xsize;i++)clearbuf[i]=' ';clearbuf[xsize]=0;
    for(i=0;i<ysize;i++){ gotoxy(xp,yp+i+1); cprintf("%s",clearbuf); }
    ysize=ysize-2;
    gotoxy(xp,yp+ysize+1); for(i=0;i<xsize;i++) cprintf("");
    while(key!=13) {
        switch(key)
        {
            case 73: menu_cur=menu_cur-ysize; break;
            case 81: menu_cur=menu_cur+ysize; break;
            case 72: menu_cur--; break;
            case 80: menu_cur++; break;
            case 27:
                tui_textback(SETTB); tui_textcolr(SETTC);
                return -1;
            default:
                tui_textback(SETTB); tui_textcolr(SETTC);
                if(key!=0)
                for(i=0;i<count;i++)
                {
                    if(p[i].val!=-1)
                    {
                        if(p[i].data[p[i].val]<91)
                            if(key==p[i].data[p[i].val]+32)return i;
                        else
                            if(key==p[i].data[p[i].val])return i;
                    }
                }
            break;
        }
        if(count-y<ysize) z=count; else z=ysize;
        if(menu_cur>z-1) { y=y+menu_cur-z+1; menu_cur=z-1; }
        if(menu_cur<0) { y=y+menu_cur-1; menu_cur=0; }
        if(y<0) y=0;
        if(y>count-z) y=count-z;
        color = 0x1f;
        for(i=y;i<y+z;i++)
        {
            if(i==y+menu_cur) { tui_textback(SETTC); tui_textcolr(SETTB); }
            else { tui_textback(SETTB); tui_textcolr(SETTC); }

            gotoxy(xp,yp+i-y+1);
            strcpy(tmp, p[i].data);
            for (pos=strlen(tmp);pos<21;pos++)tmp[pos]=' ';
            cprintf("%s",tmp);

	    if (p[i].val != -1) {
		gotoxy(xp+p[i].val,yp+i-y+1);
		tui_textcolr(SETHL); cprintf("%c",p[i].data[p[i].val]);
	    }
        }
        tui_textback(SETTB); tui_textcolr(SETTC);
        gotoxy(xp, yp+ysize+2);
        strcpy(tmp, p[y+menu_cur].data);
        for (pos=strlen(tmp);pos<21;pos++)tmp[pos]=' ';
        cprintf("%s", tmp);

        key = getch();
    }
    cfree(tmp);
    return y+menu_cur;
}